<?php

  class env
  {
    public $config_file;
    public $PATHES;
    public $PARAMS;
    public $CONFIG;
    public $prefix;
    public $base_url;
    public $add_url;
    public $bdd;
    public $acces;
    public $DEFAULT_ALLOW;

    function __construct($config_file, $path_prefix = "")
    { $this->config_file = $config_file;
      if(file_exists($config_file))
      { $this->PATHES = array();
        $this->bdd = array();
        $this->CONFIG = array();
        require $config_file;
        if(file_exists($path_prefix.$this->path("app")."config.xml"))
        { $app_config = simplexml_load_file($path_prefix.$this->path("app")."config.xml");
          foreach($app_config->pathes[0] as $path_name => $path_value)
          { $this->PATHES[$path_name] = $this->path("app").utf8_decode($path_value);
          }
          $this->PARAMS = array();
          foreach($app_config->params[0] as $code_param => $get_param)
          { $this->PARAMS[$code_param] = utf8_decode($get_param);
          }
          $this->init_base_url();
          $this->prefix = utf8_decode($app_config->prefix);
          $this->DEFAULT_ALLOW = false;
        }
        else
        { echo "[erreur] config : impossible de trouver le fichier de configuration pour l'application";
          exit();
        }
      }
      else
      { echo "[erreur] config : impossible de trouver le fichier de configuration pour l'installation";
        exit();
      }
    }

    function set_config($config)
    { if(is_array($config))
      { foreach($config as $key => $value) $this->CONFIG[$key] = $value;
        return true;
      }
      return false;
    }

    function init_base_url()
    { $_params = $_SERVER["QUERY_STRING"];
      $v_params = explode("&", $_params);
      $this->base_url = $_SERVER["SCRIPT_NAME"]."?";
      $this->add_url = "?";
      $FIRST = true;
      foreach($v_params as $param)
      { $key = strpos($param, "=") === false ? $param : substr($param, 0, strpos($param, "="));
        if(!$this->is_a_param($key))
        { if(!$FIRST)
          { $this->base_url .= "&";
            $this->add_url .= "&";
          }
          else $FIRST = false;
          $this->base_url .= $param;
          $this->add_url .= $param;
        }
      }
    }

    function is_a_param($key)
    { foreach($this->PARAMS as $_key => $_value) if(strcmp($key, $_value) == 0) return true;
      return false;
    }

    function path($name) { return $this->PATHES[$name]; }
    function param($name) { return $this->PARAMS[$name]; }
    function config($name) { return $this->CONFIG[$name]; }

    function url($_params, $script_name = null)
    { if(isset($script_name))
      { $v_path = explode("/", $_SERVER["SCRIPT_NAME"]);
        $path = "";
        if(count($v_path) > 2) for($i = 0; $i < (count($v_path) - 1); $i++) $path .= $v_path[$i]."/";
        $script_name = ($path ? $path : "/").$script_name;
      }
      else $script_name = $_SERVER["SCRIPT_NAME"];
      $url = $script_name.$this->add_url;
      foreach($_params as $key => $value)
      { $url .= strcmp(substr($url, -1, 1), "?") == 0 ? "" : "&";
        $url .= $this->param($key)."=".$value;
      }
      return $url;
    }

    function out_file_exists($file)
	 { return
      ( $this->config("out") ?
          file_exists($this->config("out").$file) ||
          file_exists($this->path("out").$file) ||
          file_exists($this->path("dist_out").$file)
        : file_exists($this->path("out").$file) ||
          file_exists($this->path("dist_out").$file)
      );
	 }

    function out_file($file)
	 { return
      ( $this->config("out") ?
          ( file_exists($this->config("out").$file) ?
              $this->config("out").$file
            : ( file_exists($this->path("out").$file) ?
                  $this->path("out").$file
                : (file_exists($this->path("dist_out").$file) ? $this->path("dist_out").$file : $file)
              )
          )
        : ( file_exists($this->path("out").$file) ?
              $this->path("out").$file
            : (file_exists($this->path("dist_out").$file) ? $this->path("dist_out").$file : $file)
          )
      );
	 }

    function action_ok($action)
    { return
      ( isset($this->acces["actions"][$action]) ?
         $this->acces["actions"][$action][$this->user["statut"]]
        :($this->DEFAULT_ALLOW ? true : false)
      );
	 }

    function interface_ok($interface)
    { return
      ( isset($this->acces["interfaces"][$interface]) ?
         $this->acces["interfaces"][$interface][$this->user["statut"]]
        :($this->DEFAULT_ALLOW ? true : false)
      );
    }

  }

?>